//+------------------------------------------------------------------+
//|                                                    ZoneTrade.mq4 |
//|                                                           Duke3D |
//|                                             duke3datomic@mail.ru |
//+------------------------------------------------------------------+
#property copyright "Duke3D"
#property link      "duke3datomic@mail.ru"

#property indicator_chart_window

extern int ShiftBar              = 0;
extern color GreenZone        = Green;
extern color RedZone          = Red;
extern color GreyZone         = Gray;
double AC_0;
double AC_1;
double AO_0;
double AO_1;
string name;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   //name=StringConcatenate("ZoneTrade",DoubleToStr(total,0));

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   for(int i=0;;i++)
    {
    name=StringConcatenate("ZoneTrade",DoubleToStr(i,0));
    if(!ObjectDelete(name)) break;
    }
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int counted_bars=IndicatorCounted();
   int i, limit, total = 0;
  
   if(counted_bars > 0) counted_bars--;
   limit = Bars - counted_bars;

   for(i=0;i<=limit;i++)
    {
//===================================================================================================================  
    if(IndAC(i)==1 && IndAO(i)==1)            //   
      {
      name=StringConcatenate("ZoneTrade",DoubleToStr(i,0));
      GreatObject(name,Time[i]+Period()/2,High[i],Time[i]-Period()/2,Low[i],RedZone);
      }
//===================================================================================================================      
    if(IndAC(i)==2 && IndAO(i)==2)            //  
      {
      name=StringConcatenate("ZoneTrade",DoubleToStr(i,0));
      GreatObject(name,Time[i]+Period()/2,High[i],Time[i]-Period()/2,Low[i],GreenZone);
      }
//===================================================================================================================
    if(IndAC(i)==1 && IndAO(i)==2)            //  
      {
      name=StringConcatenate("ZoneTrade",DoubleToStr(i,0));
      GreatObject(name,Time[i]+Period()/2,High[i],Time[i]-Period()/2,Low[i],GreyZone);
      }
//===================================================================================================================
    if(IndAC(i)==2 && IndAO(i)==1)            //  
      {
      name=StringConcatenate("ZoneTrade",DoubleToStr(i,0));
      GreatObject(name,Time[i]+Period()/2,High[i],Time[i]-Period()/2,Low[i],GreyZone);
      }
//===================================================================================================================     
    Print("Time=",DoubleToStr(Time[i],2));      //  
    Print("iTime=",iTime(Symbol(),0,i));      //  
    Print("Period=",Period());
    }  
  return(0);
  }
//+---------------------------------------------------------------------------------+
//|                                                           |
//+---------------------------------------------------------------------------------+
int GreatObject(string NameObj, datetime Time1, double Price1, datetime Time2, double Price2, color ColorObj)
  {
  ObjectCreate(NameObj, OBJ_RECTANGLE, 0, Time1, Price1, Time2, Price2);
  ObjectSet(NameObj, OBJPROP_COLOR, ColorObj);
  }
//===================================================================================================================     
int IndAC(int Shift)
   {
   int DirectionAC;
   AC_0 = iAC(Symbol(),0,Shift);
   AC_1 = iAC(Symbol(),0,Shift-1);
   Print("AC_0=",AC_0," AC_1=",AC_1);
   if(AC_0>AC_1) {DirectionAC = 1;}               //  
   if(AC_0<AC_1) {DirectionAC = 2;}               //  
   Print("DirectionAC=",DirectionAC);
   return(DirectionAC);
   }
//===================================================================================================================     
int IndAO(int Shift)
   {
   int DirectionAO;
   AO_0 = iAO(Symbol(),0,Shift);
   AO_1 = iAO(Symbol(),0,Shift-1);
   Print("AO_0=",AO_0," AO_1=",AO_1);
   if(AO_0>AO_1) {DirectionAO = 1;}               //  
   if(AO_0<AO_1) {DirectionAO = 2;}               //  
   Print("DirectionAO=",DirectionAO);
   return(DirectionAO);
   }
//===================================================================================================================     
   